-- INIT1+.sql
-------------------------------------------------------------------
-- AZ ORACLE MINTATBLK KZVETLEN LTREHOZSA                   --
-- (kiegszt megszortsokkal, tulajdonsgaik lekrdezsvel ) --
-------------------------------------------------------------------
-- Utols javts dtuma: 2005.11.20.
-------------------------------------------------------------------

SET echo OFF
SET feedback OFF

DROP TABLE EMP;
DROP TABLE DEPT;
DROP TABLE BONUS;
DROP TABLE SALGRADE;

ALTER SESSION SET NLS_DATE_LANGUAGE = ENGLISH;
ALTER SESSION SET NLS_DATE_FORMAT = 'DD-MON-YYYY';

CREATE TABLE DEPT 
    (DEPTNO              NUMBER(2) NOT NULL,
     DNAME               VARCHAR2(14),
     LOC                 VARCHAR2(13),
  CONSTRAINT DEPT_PRIMARY_KEY PRIMARY KEY (DEPTNO));

INSERT INTO DEPT VALUES (10,'ACCOUNTING','NEW YORK');
INSERT INTO DEPT VALUES (20,'RESEARCH','DALLAS');
INSERT INTO DEPT VALUES (30,'SALES','CHICAGO');
INSERT INTO DEPT VALUES (40,'OPERATIONS','BOSTON');

CREATE TABLE EMP
    (EMPNO               NUMBER(4) NOT NULL,
     ENAME               VARCHAR2(10) CONSTRAINT CN NOT NULL CONSTRAINT CU UNIQUE,
     JOB                 VARCHAR2(9),
     MGR                 NUMBER(4) CONSTRAINT EMP_SELF_KEY REFERENCES EMP (EMPNO),
     HIREDATE            DATE,
     SAL                 NUMBER(7,2),
     COMM                NUMBER(7,2),
     DEPTNO              NUMBER(2) NOT NULL,
  CONSTRAINT EMP_FOREIGN_KEY FOREIGN KEY (DEPTNO) REFERENCES DEPT (DEPTNO),
  CONSTRAINT EMP_PRIMARY_KEY PRIMARY KEY (EMPNO));

INSERT INTO EMP VALUES (7839,'KING','PRESIDENT',NULL,'17-NOV-1981',5000,NULL,10);
INSERT INTO EMP VALUES (7698,'BLAKE','MANAGER',7839,'1-MAY-1981',2850,NULL,30);
INSERT INTO EMP VALUES (7782,'CLARK','MANAGER',7839,'9-JUN-1981',2450,NULL,10);
INSERT INTO EMP VALUES (7566,'JONES','MANAGER',7839,'2-APR-1981',2975,NULL,20);
INSERT INTO EMP VALUES (7654,'MARTIN','SALESMAN',7698,'28-SEP-1981',1250,1400,30);
INSERT INTO EMP VALUES (7499,'ALLEN','SALESMAN',7698,'20-FEB-1981',1600,300,30);
INSERT INTO EMP VALUES (7844,'TURNER','SALESMAN',7698,'8-SEP-1981',1500,0,30);
INSERT INTO EMP VALUES (7900,'JAMES','CLERK',7698,'3-DEC-1981',950,NULL,30);
INSERT INTO EMP VALUES (7521,'WARD','SALESMAN',7698,'22-FEB-1981',1250,500,30);
INSERT INTO EMP VALUES (7902,'FORD','ANALYST',7566,'3-DEC-1981',3000,NULL,20);
INSERT INTO EMP VALUES (7369,'SMITH','CLERK',7902,'17-DEC-1980',800,NULL,20);
INSERT INTO EMP VALUES (7788,'SCOTT','ANALYST',7566,'19-APR-1987',3000,NULL,20);
INSERT INTO EMP VALUES (7876,'ADAMS','CLERK',7788,'23-MAY-1987',1100,NULL,20);
INSERT INTO EMP VALUES (7934,'MILLER','CLERK',7782,'23-JAN-1982',1300,NULL,10);

CREATE TABLE BONUS (
 ENAME               VARCHAR2(10),
 JOB                 VARCHAR2(9),
 SAL                 NUMBER,
 COMM                NUMBER);

CREATE TABLE SALGRADE (
 GRADE               NUMBER,
 LOSAL               NUMBER,
 HISAL               NUMBER);

INSERT INTO SALGRADE VALUES (1,700,1200);
INSERT INTO SALGRADE VALUES (2,1201,1400);
INSERT INTO SALGRADE VALUES (3,1401,2000);
INSERT INTO SALGRADE VALUES (4,2001,3000);
INSERT INTO SALGRADE VALUES (5,3001,9999);

ALTER SESSION SET NLS_DATE_LANGUAGE = HUNGARIAN;
ALTER SESSION SET NLS_DATE_FORMAT = 'YY-MON-DD';

-- A mintatblk listzsa
SET numwidth 5
PROMPT emp:
SELECT * FROM EMP;
PROMPT dept:
SELECT * FROM DEPT;
PROMPT bonus:
SELECT * FROM BONUS;
PROMPT salgrade:
SELECT * FROM SALGRADE;
SET numwidth 10
PROMPT

-- A mintatblk struktrjnak lekrdezse
SET linesize 30
PROMPT DESC emp:
DESC emp
PROMPT DESC dept:
DESC dept
PROMPT DESC bonus:
DESC bonus
PROMPT DESC salgrade:
DESC salgrade
SET linesize 400

-- A mintatblk megszortsainak lekrdezse
BREAK ON Tulajdonos ON TablaNeve
COLUMN Tulajdonos    FORMAT A11  HEADING "|Tulajdonos"
COLUMN TablaNeve     FORMAT A10  HEADING "|TblaNv"
COLUMN OszlopNeve    FORMAT A12  HEADING "|OszlopNv"
COLUMN Megszoritas   FORMAT A18  HEADING "Megszorts|Neve"
COLUMN Tipus         FORMAT A7   HEADING "|Tipusa"
COLUMN Leiras        FORMAT A25  HEADING "|Lersa"
SELECT SUBSTR(LOWER(user_constraints.owner),1,10)      Tulajdonos,
       SUBSTR(LOWER(user_constraints.table_name),1,10) TablaNeve,
       RPAD(user_cons_columns.column_name,12)          OszlopNeve,
       SUBSTR(user_constraints.constraint_name,1,20)   Megszoritas,
       RPAD(user_constraints.constraint_type,6)        Tipus,
       user_constraints.search_condition               Leiras
  FROM user_constraints, user_cons_columns
  WHERE (user_constraints.constraint_name = 
           user_cons_columns.constraint_name)  AND
        (LOWER(user_constraints.table_name) IN ('emp','dept','bonus','salgrade'))
  ORDER BY Tulajdonos ASC, TablaNeve ASC, OszlopNeve ASC;
CLEAR BREAKS
CLEAR COLUMNS
PROMPT

SET feedback 6
